'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/* eslint no-bitwise: 0 */

var _require = require('graphql/language/parser'),
    parse = _require.parse;

function nonSecureHash(s) {
  var hash = 0;
  for (var i = 0; i < s.length; i++) {
    var char = s.charCodeAt(i);
    var mixed = (hash << 5) - hash;
    hash = mixed + char;
    hash = hash & hash; // Convert to 32bit integer
  }
  return hash;
}

var NotFragment = function () {
  function NotFragment(value) {
    _classCallCheck(this, NotFragment);

    this.name = String(value);
  }

  _createClass(NotFragment, [{
    key: 'collectFragments',
    value: function collectFragments(acc) {
      return acc;
    }
  }]);

  return NotFragment;
}();

var Fragment = function () {
  function Fragment(segments, childFragments) {
    _classCallCheck(this, Fragment);

    this.segments = segments;
    this.childFragments = childFragments.map(function (f) {
      if (!(f instanceof Fragment)) {
        return new NotFragment(f);
      }
      return f;
    });

    var hash = nonSecureHash([].concat(_toConsumableArray(segments), _toConsumableArray(this.childNames())).join(''));
    this.name = 'fragment_' + Math.abs(hash).toString(36);
  }

  _createClass(Fragment, [{
    key: 'format',
    value: function format() {
      return 'fragment ' + this.name + ' ' + interleaveStrings(this.segments, this.childNames()).replace('...', '');
    }
  }, {
    key: 'childNames',
    value: function childNames() {
      return this.childFragments.map(function (f) {
        return f.name;
      });
    }
  }, {
    key: 'collectFragments',
    value: function collectFragments(acc) {
      var children = this.childFragments.reduce(function (acc, f) {
        return f.collectFragments(acc);
      }, acc);
      return [this].concat(_toConsumableArray(children));
    }
  }]);

  return Fragment;
}();

function createFragment(segments) {
  for (var _len = arguments.length, childFragments = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    childFragments[_key - 1] = arguments[_key];
  }

  return new Fragment(segments, childFragments);
}

function interleaveStrings(array1, array2) {
  return array1.map(function (string, i) {
    return string + (array2[i] || '');
  }).join('');
}

function uniqueFragments(collectedFragments) {
  var uniqueFragmentMap = {};
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = collectedFragments[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var fragment = _step.value;

      uniqueFragmentMap[fragment.name] = fragment;
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  return Object.keys(uniqueFragmentMap).sort().map(function (name) {
    return uniqueFragmentMap[name];
  });
}

function createQuery(segments) {
  for (var _len2 = arguments.length, childFragments = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
    childFragments[_key2 - 1] = arguments[_key2];
  }

  var root = new Fragment([], childFragments);
  var collectedFragments = root.collectFragments([]);
  collectedFragments.shift(); // Skip root

  var fragmentsString = uniqueFragments(collectedFragments).map(function (fragment) {
    return fragment.format();
  }).join('\n');
  var clonedSegments = segments.slice();
  clonedSegments[clonedSegments.length - 1] += fragmentsString;
  return parse(interleaveStrings(clonedSegments, root.childNames()));
}

module.exports = {
  createQuery: createQuery,
  createFragment: createFragment
};